#include "main.h"

// delete LIST
void LIST_done( LIST *list ) {
    ITEM *q, *p;

    if ( list == NULL )
        error( 0, "Pointer is NULL !" );

    p = list->head;
    while( p != NULL ) {
        q = p;
        p = p->next;
        ITEM_delete( q );
    }
    list->head = list->tail = NULL;
    list->count = 0;
}

// add to LIST
void LIST_add( LIST *list, char *s ) {
    ITEM *item;

    if ( list == NULL )
        error( 0, "Pointer is NULL !" );

    item = ITEM_create( s );

    if ( list->count == 0 ) {
        list->head = list->tail = item;
    }
    else {
        ( list->tail )->next = item;
        list->tail = item;
    }
    list->count++;
}

// get item with number 'index'
char *LIST_item( LIST *list, int index ) {
    ITEM *item;

    if ( list == NULL )
        error( 0, "Pointer is NULL !" );

    for ( item = list->head; index && item != NULL; item = item->next )
        index--;

    return item == NULL ? NULL : item->data;
}

// find item in LIST
int  LIST_find( LIST *list, char *str ) {
    ITEM *item;

    if ( list == NULL )
        error( 0, "Pointer is NULL !" );

    for ( item = list->head; item != NULL; item = item->next )
        if ( stricmp( item->data, str ) == 0 )
            return 1;

    return 0;
}
