#if !defined( __LIST_H__ )
#define __LIST_H__

// Element of list
typedef struct _ITEM {
    char *data;         // data
    struct _ITEM *next; // ptr of next item
} ITEM;

ITEM *ITEM_create( char *s );       // create new ITEM
void  ITEM_delete( ITEM *item );    // delete ITEM

// String NULL or len == 0
#define empty_str(s)  ( (s) == NULL || *(s) == '\0' )

// List
typedef struct _LIST {
    ITEM *head;         // ptr of head
    ITEM *tail;         // ptr of tail
    int  count;         // count of item
} LIST;

void  LIST_done( LIST *list );              /* delete all item */
void  LIST_add ( LIST *list, char *s );     /* add to end of list */
char *LIST_item( LIST *list, int index );   /* get item with number # */
int   LIST_find( LIST *list, char *s );     /* find */

#endif
