#if !defined( __MAIN_H__ )
#define __MAIN_H__

#define VERSION "3.11"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <process.h>

#include "list.h"       /* define LIST & */

#define TRUE  1
#define FALSE 0

#define MAX_STR 256

/************************************************************************\
    define EXT_xxx
\************************************************************************/

/* If not extention != EXT_xxx - C & CPP files !!! */

#define EXT_ASM  ".ASM"     /* Extention for ASM file */
#define EXT_OBJ  ".OBJ"     /* Extention for OBJ file */
#define EXT_LIB  ".LIB"     /* Extention for LIB file */


/************************************************************************\
    define COMPILE_xxx
\************************************************************************/

#define COMPILE_PROGRAM  "CC386.EXE"
#define COMPILE_RESPONSE "CC386.$$$"

#undef COMPILE_DEFAULT_OPTIONS  /* No default options & files */

/************************************************************************\
    define ASSEMBLE_xxx
\************************************************************************/

#define ASSEMBLE_PROGRAM  "TASM.EXE"
#define ASSEMBLE_RESPONSE "TASM.$$$"

#define ASSEMBLE_DEFAULT_OPTIONS "/ml /t"   /* Default options for TASM */

/************************************************************************\
    define LINK_xxx
\************************************************************************/

#define LINK_PROGRAM  "TLINK.EXE"
#define LINK_RESPONSE "TLINK.$$$"

#define LINK_DEFAULT_OPTIONS "/3 /c"    /* Default options for TLINK */

#define LINK_DEFAULT_OBJ  "C0DOS.OBJ"   /* Startup .OBJ */
#define LINK_DEBUG_OBJ   "C0DOSD.OBJ"   /* Startup .OBJ for debug */

#define LINK_DEFAULT_LIB "CLDOS.LIB"    /* Run-time library */

/************************************************************************\
    extern List's
\************************************************************************/

extern LIST compile_opt;        // option for COMPILE
extern LIST assemble_opt;       // option for ASSEMBLE
extern LIST link_opt;           // option for LINK

extern LIST cpp_files;          // list files for COMPILE
extern LIST asm_files;          // list files for ASSEMBLE
extern LIST obj_files;          // list all .OBJ files
extern LIST lib_files;          // list all .LIB files

/************************************************************************\
    extern Var's
\************************************************************************/

// == TRUE, if need ...
extern int _compile;        // compile, default == TRUE
extern int _assemble;       // assemble, default == TRUE
extern int _link;           // link, default == TRUE

extern int _debug;          // debug, default == FALSE
extern int _nodefault;      // no default lib, default == FALSE
extern int _keep_temp;      // keep response, default == FALSE
extern int _map_file;       // generate .MAP file, default == FALSE

/************************************************************************\
    extern func's
\************************************************************************/

/* ERROR.C */

void error( int err, char *msg );   // Output msg and exit

/* PARAM.C */

void get_config_file( char *exe_name );     // Read options from CL386.CFG
void get_environ_var( char *var);     // Read options from env var CL386
void get_params( int __argc, char *__argv[] ); // Read options from CmdLine

/* OPTION.C */

// Is option ?
#define is_option(s) ( *(s) == '-' || *(s) == '/' || *(s) == '+' )

void get_option( char *opt );   // Check option
void help( void );              // Output help & exit

/* SOURCE.C */

void get_source_file( char *file );  // Add source file to List's

/* WORK.C */

void compile_response( void );      // Make COMPILE response file
void assemble_response( void );     // Make ASSEMBLE response file
void link_response( void );         // Make LINK response file
void delete_response( void );       // Delete all response files

void compile( void );       // Compile to .ASM
void assemble( void );      // Assemble to .OBJ
void link( void );          // Make to .EXE

#endif
