// #include <stdio.h>
// #include <stdlib.h>
#include "main.h"
// #include "param.h"
// #include "option.h"
// #include "source.h"

static int get_param_file( char *file );
static void get_param_str( char *str );
static void get_argument( char *arg );

void get_config_file( char *exe_name ) {
    char file[ _MAX_PATH ];
    char disk[ _MAX_DRIVE ];
    char path[ _MAX_DIR ];
    char name[ _MAX_FNAME ];
    char ext [ _MAX_EXT ];

    _splitpath( exe_name, disk, path, name, ext );
    _makepath( file, NULL, NULL, name, ".CFG" );
    if ( ! get_param_file( file ) ) {
        _makepath( file, disk, path, name, ".CFG" );
        get_param_file( file );
    }
}

void get_environ_var( char *var) {
    char *env = getenv( var );
    if ( env )
        get_param_str( env );
}

void get_params( int __argc, char *__argv[] ) {
    int i;
    for ( i = 0; i < __argc; i++ )
        get_argument( __argv[ i ] );
}

void get_argument( char *arg ) {
    if ( is_option( arg ) )                 // -X , +X or /X
        get_option( arg );
    else if ( *arg == '@' ) {               // @filename
        if ( ! get_param_file( arg + 1 )  )
            error( 1, arg + 1 );
    }
    else
        get_source_file( arg );             // file.ext
}

int get_param_file( char *file ) {
    static char s[ MAX_STR ];
    FILE *f = fopen( file, "rt" );

    if ( f == NULL )
        return 0;

    while( fgets( s, MAX_STR - 1, f) != NULL )
        get_param_str( s );

    fclose( f );
    return 1;

}

void get_param_str( char *s ) {
    char arg[ MAX_STR ];
    int  len;

    for (len = 0; *s; s++ ) {
        if ( *s == ' ' || *s == '\t' || *s == '\n' ) {
            if ( len > 0 ) {
                arg[ len ] = '\0';
                get_argument( arg );
            }
            arg[ len = 0 ] = '\0';
        }
        else {
            arg[ len++ ] = *s;
        }
    }

    if ( len > 0 ) {
        arg[ len ] = '\0';
        get_argument( arg );
    }
}
